// Generated by CoffeeScript 1.10.0
(function() {
  var Browser, BrowserWindow, Locker, Watcher, app, chokidar, cson, exec, fork, fs, fse, ipc, mainWindow,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  require('crash-reporter').start();

  fse = require("fs-extra");

  chokidar = require("chokidar");

  cson = require("cson");

  fs = require("fs");

  exec = require("child_process").exec;

  fork = require("child_process").fork;

  app = require('app');

  BrowserWindow = require('browser-window');

  ipc = require('electron').ipcMain;

  mainWindow = null;

  Locker = (function() {
    function Locker() {
      this.lock = bind(this.lock, this);
      this.check = bind(this.check, this);
      this.unlock = bind(this.unlock, this);
    }

    Locker.prototype.path = ".lock";

    Locker.prototype.unlock = function() {
      return fse.removeSync(this.path);
    };

    Locker.prototype.check = function() {
      if (fs.existsSync(this.path)) {
        console.log("exists " + this.path);
        return app.quit();
      }
    };

    Locker.prototype.lock = function() {
      return fse.ensureFileSync(this.path);
    };

    return Locker;

  })();

  Watcher = (function() {
    function Watcher() {
      this.start = bind(this.start, this);
      this.restart = bind(this.restart, this);
      this.firstReadObj = {};
    }

    Watcher.prototype.restart = function() {
      var cmd;
      cmd = fse.readJsonSync("package.json").scripts.electron;
      exec(cmd);
      return setTimeout(app.quit, 0);
    };

    Watcher.prototype.start = function() {
      return chokidar.watch(["./browser/.build/"]).on("change", (function(_this) {
        return function(path) {
          if (!_this.firstReadObj[path]) {
            return _this.firstReadObj[path] = true;
          }
          if (!(path.match(/\.js$/) || _this.restartFlg)) {
            return;
          }
          _this.restartFlg = true;
          Locker.prototype.unlock();
          return _this.restart();
        };
      })(this));
    };

    return Watcher;

  })();

  module.exports = Browser = (function() {
    function Browser() {
      this.sendMsg = bind(this.sendMsg, this);
      this.ipcEvent = bind(this.ipcEvent, this);
      this.start = bind(this.start, this);
      this.init = bind(this.init, this);
    }

    Browser.prototype.configCson = ".config.cson";

    Browser.prototype.init = function() {
      var error;
      try {
        this.config = cson.load(this.configCson);
      } catch (error) {
        this.config = cson.load(this.configCson.slice(1));
      }
      this.option = this.config["browser-window"];
      return this;
    };

    Browser.prototype.start = function(url) {
      this.url = url;
      Locker.prototype.check();
      Locker.prototype.lock();
      this.watcher = new Watcher();
      this.watcher.start();
      this.ipcEvent();
      app.on('window-all-closed', (function(_this) {
        return function() {
          if (process.platform !== 'darwin') {
            return app.quit();
          }
        };
      })(this));
      return app.on('ready', (function(_this) {
        return function() {
          var option;
          option = JSON.parse(JSON.stringify(_this.option));
          option["web-preferences"].preload = "" + (process.cwd()) + _this.option["web-preferences"].preload;
          mainWindow = new BrowserWindow(option);
          mainWindow.setAlwaysOnTop(true);
          if (!_this.url.match(/^(http|\/\/)/)) {
            _this.url = "file://" + (process.cwd()) + _this.url;
          }
          mainWindow.loadUrl(_this.url);
          mainWindow.openDevTools();
          mainWindow.webContents.on("did-finish-load", function() {
            if (!_this.option["always-on-top"]) {
              return mainWindow != null ? mainWindow.setAlwaysOnTop(false) : void 0;
            }
          });
          mainWindow.on('closed', function() {
            return mainWindow = null;
          });
          mainWindow.on("close", function(e) {
            var csonString, wh, xy;
            Locker.prototype.unlock();
            if (!(mainWindow != null ? mainWindow.getPosition : void 0)) {
              return;
            }
            xy = mainWindow.getPosition();
            wh = mainWindow.getSize();
            _this.option.x = xy[0];
            _this.option.y = xy[1];
            _this.option.width = wh[0];
            _this.option.height = wh[1];
            csonString = cson.createCSONString(_this.config, {
              indent: "  "
            });
            fs.writeFileSync(_this.configCson, csonString);
            return mainWindow = null;
          });
          return _this.startCompiler();
        };
      })(this));
    };

    Browser.prototype.ipcEvent = function() {
      return ipc.on("restart", this.watcher.restart);
    };

    Browser.prototype.startCompiler = function() {
      return exec(fse.readJsonSync("package.json").scripts.watchAll).stdout.on("data", this.sendMsg);
    };

    Browser.prototype.sendMsg = function(msg) {
      return mainWindow != null ? mainWindow.webContents.send("browser send msg", msg) : void 0;
    };

    return Browser;

  })();

}).call(this);
